Перем Отборы;
Перем Сортировки;

// Получить список отборов для выполнения поиска.
//
// Возвращаемое значение:
//   ФиксированныйМассив из ЭлементОтбора
//
Функция Отборы() Экспорт
	Возврат Новый ФиксированныйМассив(Отборы);
КонецФункции

// Добавить отбор для выполнения поиска.
//
// Параметры:
//   Поле - Строка - Имя поля для отбора.
//   ВидСравнения - ВидСравнения - Вид сравнения.
//   Значение - Произвольный - Значение для сравнения.
//
// Возвращаемое значение:
//   ОпцииПоиска - Текущий объект.
//
Функция Отбор(Поле, ВидСравнения, Значение) Экспорт

	ЭлементОтбора = Новый ЭлементОтбора(Поле, ВидСравнения, Значение);
	Отборы.Добавить(ЭлементОтбора);

	Возврат ЭтотОбъект;

КонецФункции

// Получить список сортировок для выполнения поиска.
//
// Возвращаемое значение:
//   ФиксированныйМассив из ЭлементПорядка
//
Функция Сортировки() Экспорт
	Возврат Новый ФиксированныйМассив(Сортировки);
КонецФункции

// Добавить сортировку для выполнения поиска.
//
// Параметры:
//   ИмяПоля - Строка - Имя поля для сортировки.
//   НаправлениеСортировки - НаправлениеСортировки - Направление сортировки.
//
// Возвращаемое значение:
//   ОпцииПоиска - Текущий объект.
//
Функция СортироватьПо(ИмяПоля, НаправлениеСортировки = Неопределено) Экспорт

	ЭлементПорядка = Новый ЭлементПорядка(ИмяПоля, НаправлениеСортировки);
	Сортировки.Добавить(ЭлементПорядка);

	Возврат ЭтотОбъект;

КонецФункции

Процедура ПриСозданииОбъекта()
	Отборы = Новый Массив();
	Сортировки = Новый Массив();
КонецПроцедуры
